<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
<title>JNuke</title>
<meta http-equiv="content-type" content="text/html; charset=utf-8">
<meta name="language" content="en">
<meta name="Author" content="Cyrille Artho">
</head>

<body bgcolor="#ffffff" link="#0000c0" alink="#999999" vlink="#990033">
<table width="100%">
<tr>
<td align="LEFT" width="40%">
<p><img src="../logo-main-2013.png" alt="KTH Logo" width="70" height="70"></p>
</td>
<td align="RIGHT" width="40%">
<p><a href="http://kth.se/">KTH Royal Institute of Technology</a>
<br>
<a href="https://www.kth.se/en/csc/">School of Computer Science and Communication</a>
</td>
</tr>
</table>

<p>[&nbsp;<a href="#mirrors">mirrors</a>&nbsp;|
<a href="#overview">overview</a>&nbsp;| <a href=
"#download">download</a>&nbsp;| <a href="#authors">authors</a>&nbsp;|
<a href="#publications">publications</a>&nbsp;]</p>

<h1>JNuke</h1>

<h2>A program analysis framework for Java</h1>

<h3><font color="red">This website moved to KTH. Please update your links and bookmarks!</font></h3>

<h3><a name="mirrors" id="mirrors">Mirrors</a></h3>
<p>[ <a href="https://people.kth.se/~artho/jnuke">KTH</a> |
<a href="http://fmv.jku.at/jnuke">JKU</a> ]</p>

<h3><a name="overview" id="overview">Overview</a></h3>

<p>
JNuke is a collection of program analysis tools for Java bytecode; JNuke
itself is written in C.
</p>

<p>
JNuke is a collection of program analysis tools for Java bytecode, including:
<ul>
<li>A class loader and <a href="../papers/inlining.pdf">bytecode analysis/instrumentation framework.</a></li>
<li>A virtual machine with event listeners for run-time verification: <a href="../papers/stvr03.pdf">low-level and high-level data race analysis.</a></li>
<li>A <a href="../papers/jnuke.pdf">backtracking-capable virtual machine</a> for software model checking.</li>
<li>A <a href="../papers/466.pdf">static analysis framework</a> for Java bytecode, used to implement <a href="../papers/bl-atomicity.pdf">stale-value analysis.</a></li>
</ul>
JNuke is currently not under active development, but the existing code
base is licensed under the open source BSD license, to allow JNuke or
some of its components to be re-used. JNuke also contains about 1,800
test cases that cover corner cases for Java bytecode, which may be
interesting to test other tools.
</p>

<p>
See <a href="README">README</a> for more information.
</p>

<h3><a name="download" id="download">Download</a></h3>

<p>Due to licensing reasons, JNuke is provided in multiple archives,
each containing a separate license. The main code base is licensed under
the BSD license. To use run the regression tests of JNuke, additional
class files are needed, coming under their own license. JNuke also requires
class library files, which can be extracted from an existing JVM
installation.
</p>

<table border="0">
<tr>
<th>
Archive
</th>
<th>
License
</th>
<th>
Description
</th>
</tr>
<tr>
<td>
<a href="LICENSE">LICENSE</a>
</td>
<td>
<a href="jnuke-1.0.tar.gz"><tt>jnuke-1.0.tar.gz</tt></a>
</td>
<td>Source distribution (version 1.0)</td>
</tr>
<tr>
<td>
<a href="LICENSE-EPCC">LICENSE-EPCC</a>
</td>
<td>
<a href="jnuke-1.0-edinburgh.tar.gz"><tt>jnuke-1.0-edinburgh.tar.gz</tt></a>
</td>
<td>Java Grande Benchmark (used in some regression tests)</td>
</tr>
<tr>
<td>
<a href="LICENSE-ETH">LICENSE-ETH</a>
</td>
<td>
<a href="jnuke-1.0-eth.tar.gz"><tt>jnuke-1.0-eth.tar.gz</tt></a>
</td>
<td>Concurrency benchmarks (used in some regression tests)</td>
</tr>
<tr>
<td>
<a href="LICENSE-GNU">LICENSE-GNU</a>
</td>
<td>
<a href="jnuke-1.0-gnu.tar.gz"><tt>jnuke-1.0-gnu.tar.gz</tt></a>
</td>
<td>Java library components (GNU classpath)</td>
</tr>
<tr>
<td>
<a href="LICENSE-SUN">LICENSE-SUN</a>
</td>
<td>
<a href="jnuke-1.0-sun.tar.gz"><tt>jnuke-1.0-sun.tar.gz</tt></a>
</td>
<td>Java library class files (for reference only; should be extracted
from class files from existing JVM installation)</td>
</tr>
</table>

<h3><a name="authors" id="authors">Authors</a></h3>

Cyrille Artho,
Marcel Baur,
Armin Biere,
Pascal Eugster,
Peter Farkas,
Viktor Schuppan,
Boris Zweim&uuml;ller.

<h3>
<a name="publications">Publications about JNuke</a>
</h3>

<p>Click on the number for the bibtex entry.</p>

<table border="0" width="100%" cellpadding="5" nosave>
<tr align="left" valign="top" nosave>
<td nosave><a href="papers/artho-thesis.bib">[6]</a></td>

<td nosave>C. Artho. Combining Static and Dynamic Analysis to Find Multi-threading Faults Beyond Data Races. Diss. ETH Zurich No. 16020, Switzerland, May 2005. 
Published by Hartung-Gorre Verlag Konstanz, Germany, ISBN 3-89649-997-1, <a href="http://www.hartung-gorre.de/compscie.htm">Series of Computer Science,</a> ISSN 1611-0943.</td>

<td><a href="http://e-collection.ethbib.ethz.ch/cgi-bin/show.pl?type=diss&nr=16020&lang=en">ETH e-collection</a> | <a href="http://www.hartung-gorre.de/cs05.htm">Book</a></td>
</tr>

<tr align="left" valign="top" nosave>
<td nosave><a href="papers/Artho05-inlining.bib">[5]</a></td>

<td nosave>C. Artho, A. Biere. Subroutine Inlining and Bytecode Abstraction to Simplify Static and Dynamic Analysis. BYTECODE '05, Edinburgh, Scotland, April 2005.</td>

<td><a href="../papers/inlining.pdf">PDF</a> | <a href="../papers/inlining.ps.gz">Postscript</a> (gzipped)</td>
</tr>

<tr align="left" valign="top" nosave>
<td nosave><a href="../papers/artho05-generic-full.bib">[4]</a></td>

<td nosave>C. Artho, A. Biere. Combined Static and Dynamic Analysis. ETH Technical Report #466. Extended version of AIOOL paper.</td>

<td><a href="../papers/466.pdf">PDF</a> | <a href="../papers/466.ps.gz">Postscript</a> (gzipped)</td>
</tr>

<tr align="left" valign="top" nosave>
<td nosave><a href="../papers/Artho04-blatomicity.bib">[3]</a></td>

<td nosave>C. Artho, K. Havelund, A. Biere: Using Block-local Atomicity to Detect Stale-value Concurrency Errors. ATVA '04, Taipei, Taiwan, November 2004.</td>

<td><a href="../papers/bl-atomicity.pdf">PDF</a> | <a href="../papers/bl-atomicity.ps.gz">Postscript</a> (gzipped)
</td>
</tr>

<tr align="left" valign="top" nosave>
<td nosave><a href="../papers/Artho-etal2004.bib">[2]</a></td>

<td nosave>C. Artho, V. Schuppan, A. Biere, P. Eugster, M. Baur, B. Zweim&uuml;ller: JNuke: Efficient Dynamic Analysis for Java. CAV '04, Boston, USA, July 2004.</td>

<td><a href="../papers/jnuke.pdf">PDF</a> | <a href="../papers/jnuke.ps.gz">Postscript</a> (gzipped)
</td>
</tr>

<tr align="left" valign="top" nosave>
<td nosave><a href="../papers/Artho-etal2003.bib">[1]</a></td>

<td nosave>C. Artho, A. Biere, and K. Havelund: High-level Data Races. In: Journal on Software Testing, Verification and Reliability (STVR), 13(4). Extended Version of the VVEIS '03 paper.</td>

<td>Preprint as <a href="../papers/stvr03.pdf">PDF</a> | <a href="../papers/stvr03.ps.gz">Postscript</a> (gzipped)
</td>
</tr>
</table>

<table width="100%">
<tr>
<td align="left" valign="bottom">
<p>
E-mail: artho (at) kth (dot) se
</p>
<p>
Last update: September 8, 2016:
This website moved to KTH. Please update your links and bookmarks!
</p>
</td>

<td align="right"><img src="../logo-main-2013.png" alt="KTH Logo" width="70" height="70"></td>
</tr>
</table>     
</html>
